<template>
    <div class='mb-4 block absolute bottom-4 right-6 sm:right-14'>
        <button :disabled="disabled" @click='$emit("click")' class='ml-auto w-48 h-12 rounded-full bg-xmas-olive disabled:bg-gray-300 tracking-wider text-white font-mont flex justify-center items-center'>
            <transition name='fade'>
                <div class='flex' v-if='! $store.state.main.loading'>
                    {{ text }}
                    <component :is="iconComponent" class="h-6 w-6 ml-3 text-white" aria-hidden="true" />
                </div>
            </transition>
            <pulse-loader :loading="$store.state.main.loading" color="#fff" class='absolute mt-2'></pulse-loader>
        </button>
    </div>
</template>

<script>
import PulseLoader from 'vue-spinner/src/PulseLoader.vue'
import { LogoutIcon, ArrowCircleRightIcon, CheckIcon, ArrowCircleLeftIcon, ReplyIcon } from '@heroicons/vue/solid'
import _ from 'lodash';

export default {
    props: ['disabled', 'label', 'icon'],
    emits: ['click'],
    data() {
        return {
            text: '',
            iconComponent: '',
        }
    },
    created() {        
        this.text = this.label ?? 'Нататък'
        this.iconComponent = this.icon ? this.toIconName(this.icon) : 'ArrowCircleRightIcon';
    },
    methods: {
        toIconName: (icon) => _.camelCase(_.capitalize(icon)) + 'Icon',
    },  
    components: {
        PulseLoader,
        LogoutIcon,
        CheckIcon,
        ArrowCircleRightIcon,
        ArrowCircleLeftIcon,
        ReplyIcon
    }
}
</script>